<CsoundSynthesizer>

<CsOptions>
-odevaudio -M0 -m0 -b400
;-odevaudio -M0 -m0
</CsOptions>

<CsInstruments>

sr 	= 	44100  
ksmps 	= 	100
nchnls 	= 	2	
0dbfs	=	1	;MAXIMUM AMPLITUDE REGARDLESS OF BIT DEPTH

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FLcolor	255, 255, 255, 0, 0, 0
;			LABEL                                                | WIDTH | HEIGHT | X | Y
	FLpanel	"cpstmid - alternative tunings for MIDI driven instruments",    500,    150,    0,  0

;COUNTERS								MIN | MAX | STEP1 | STEP2 | TYPE | WIDTH | HEIGHT | X |  Y  | OPCODE
gktable, ihtable 			FLcount  "Tuning Table", 	1,     7,     1,      1,     2,     150,     25,   175,  5,    -1

;TEXT BOXES
;HANDLE	OPCODE  "LABEL",                                                                                                       						TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
iH	FLbox  	"  1 - Standard . 2 - Quarter Tones . 3 - Standard Reversed . 4 - Quarter Tones Reversed . 5 - Decatonic . 6 - Third Tones . 7 - Just Intonation", 	6,       9,    15,    500,     75,    0,  50


;SET INITIAL VALUES			VALUE | HANDLE
			FLsetVal_i	1,	ihtable

			FLpanel_end

;INSTRUCTIONS AND INFO PANEL
				FLpanel	" ", 515, 420, 512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	" cpstmid  - alternative tunings for MIDI driven instruments  ", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"The opcode 'cpstmid' is used, in place of the usual opcode   ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"that would be used for MIDI pitch scanning, to derive        ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"alternative tunings.                                         ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"Cpstmid references tuning data stored in a GEN-02 function   ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"table to derive pitches. In this function table the user must", 	1,      5,     14,    490,    15,     5, 120
ih	  	 	FLbox  	"supply information about the number of grades in the scale   ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"(i.e. '12' for equal temperament), the ratio at which the    ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"scale repeats (i.e. '2' for equal temperament), base         ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"frequency of the scale in hertz (261.626 for middle C) and   ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"then the ratios from grade to grade. For example in an       ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	"equally tempered system each subsequent grade is the product ", 	1,      5,     14,    490,    15,     5, 240
ih		 	FLbox  	"of the previous grade and the 1/12 root of 2 (about 1.05946).", 	1,      5,     14,    490,    15,     5, 260
ih		 	FLbox  	"This example offers 6 different tuning systems.              ", 	1,      5,     14,    490,    15,     5, 280
ih		 	FLbox  	"1 - equal temperament                                        ", 	1,      5,     14,    490,    15,     5, 300
ih		 	FLbox  	"2 - quarter tone scale                                       ", 	1,      5,     14,    490,    15,     5, 320
ih		 	FLbox  	"3 - equal temperament upside-down                            ", 	1,      5,     14,    490,    15,     5, 340
ih		 	FLbox  	"4 - quarter tones upside-down                                ", 	1,      5,     14,    490,    15,     5, 360
ih		 	FLbox  	"5 - an octave divided into 10 equal intervals                ", 	1,      5,     14,    490,    15,     5, 380
ih		 	FLbox  	"6 - third tones scale                                        ", 	1,      5,     14,    490,    15,     5, 400

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

instr		1
	icps	cpstmid		i(gktable)	;PITCH VALUES ARE READ IN FROM THE MIDI KEYBOARD BUT
						;THE ARE TRANSFORMED ACCORDING TO THE RULES LAID DOWN IN THE FUNCTION TABLE
						;REFERENCED BY 'ITUNINGTABLE'     
	
	iamp	ampmidi 0.2			;KEY VELOCITIES READ IN FROM MIDI KEYBOARD
	
	;PERCUSSIVE-TYPE AMPLITUDE ENVELOPE
	;		     | ATTACK_TIME |   | DECAY_TIME |      | RELEASE_TIME |
	aenv	expsegr	.001,     .01,       1,      5,       .001,       2,         .001	
	asig	oscil	aenv*iamp, icps, 99	;CREATE AN AUDIO SIGNAL USING AS OSCILLATOR BASED ON FUNCTION TABLE 99 
	icfoct	veloc	6,12
	asig	butlp	asig, cpsoct(icfoct)
		outs	asig, asig		;SEND THE AUDIO SIGNAL CREATED BY THE OSCILLATOR TO THE SPEAKERS
endin

</CsInstruments>

<CsScore>
;TUNING TABLES:
;STANDARD
;FN_NUM | INIT_TIME | SIZE | GEN_ROUTINE | NUM_GRADES | REPEAT | BASE_FREQ | BASE_KEY_MIDI | TUNING_RATIOS:-0-|----1----|---2----|----3----|----4----|----5----|----6----|----7----|----8----|----9----|----10----|---11----|-12-|
f  1          0        64        -2            12          2     261.626          60                        1  1.059463 1.1224619 1.1892069 1.2599207 1.33483924 1.414213 1.4983063 1.5874001 1.6817917 1.7817962 1.8877471   2
;QUARTER TONES
;fn_num | init_time | size | gen_routine | num_grades | repeat | base_freq | base_key_midi | tuning_ratios:-0-|----1----|---2----|----3----|----4----|----5----|----6----|----7----|----8----|----9----|----10----|---11----|---12---|---13----|----14---|---15--|---16----|----17---|---18----|---19--|---20----|---21----|---22----|---23---|-24-|
f  2          0        64        -2            24          2     261.626          60                        1  1.0293022 1.059463 1.0905076 1.1224619 1.1553525 1.1892069 1.2240532 1.2599207 1.2968391 1.33483924 1.3739531 1.414213 1.4556525 1.4983063 1.54221 1.5874001 1.6339145 1.6817917 1.73107 1.7817962 1.8340067 1.8877471 1.9430623  2
;STANDARD REVERSED
;fn_num | init_time | size | gen_routine | num_grades | repeat | base_freq | base_key_midi | tuning_ratios:-0-|----1----|---2----|----3----|----4----|----5----|----6----|----7----|----8----|----9----|----10----|---11----|-12-|
f  3          0        64        -2            12         .5     261.626          60                        2 1.8877471 1.7817962 1.6817917 1.5874001 1.4983063 1.414213 1.33483924 1.2599207 1.1892069 1.1224619 1.059463    1                                      
;QUARTER TONES REVERSED
;fn_num | init_time | size | gen_routine | num_grades | repeat | base_freq | base_key_midi | tuning_ratios:-0-|----1----|---2----|----3----|----4----|----5----|----6----|----7----|----8----|----9----|----10----|---11----|---12---|---13----|----14---|---15--|---16----|----17---|---18----|---19--|---20----|---21----|---22----|---23---|-24-|
f  4          0        64        -2            24         .5     261.626          60                        2 1.9430623 1.8877471 1.8340067 1.7817962 1.73107 1.6817917 1.6339145 1.5874001 1.54221 1.4983063 1.4556525 1.414213 1.3739531 1.33483924 1.2968391 1.2599207 1.2240532 1.1892069 1.1553525 1.1224619 1.0905076 1.059463 1.0293022   1
;DECATONIC
;fn_num | init_time | size | gen_routine | num_grades | repeat | base_freq | base_key_midi | tuning_ratios:-0-|----1----|---2----|----3----|----4----|----5----|----6----|----7----|----8----|----9----|----10----|
f  5          0        64        -2            10          2     261.626          60                        1  1.0717734 1.148698 1.2311444 1.3195079 1.4142135 1.5157165 1.6245047 1.7411011 1.8660659      2
;THIRD TONES
;fn_num | init_time | size | gen_routine | num_grades | repeat | base_freq | base_key_midi | tuning_ratios:-0-|----1----|----2----|----3----|----4----|----5----|----6----|----7----|----8----|----9----|----10----|---11----|----12---|---13----|----14---|---15---|---16----|----17---|---18----|---19----|---20----|---21----|---22----|---23----|----24----|----25----|----26----|----27----|----28----|----29----|----30----|----31----|----32----|----33----|----34----|----35----|----36----|
f  6          0        64        -2            36          2     261.626          60                        1  1.0194406 1.0392591 1.059463 1.0800596  1.1010566 1.1224618 1.1442831 1.1665286 1.1892067 1.2123255  1.2358939 1.2599204 1.284414  1.3093838 1.334839 1.3607891 1.3872436 1.4142125 1.4417056 1.4697332 1.4983057 1.5274337 1.5571279 1.5873994  1.6182594   1.6497193 1.6817909  1.7144859  1.7478165  1.7817951  1.8164343  1.8517469  1.8877459  1.9244448  1.9618572       2
;JUST INTONATION
;FN_NUM | INIT_TIME | SIZE | GEN_ROUTINE | NUM_GRADES | REPEAT | BASE_FREQ | BASE_KEY_MIDI | TUNING_RATIOS:-0-|----1----|---2----|----3----|----4----|----5----|----6----|----7----|----8----|----9----|----10----|---11----|-12-|
f  7          0        64        -2            12          2     261.626          60                        1  [16/15]   [9/8]      [6/5]    [5/4]     [4/3]     [45/32]    [3/2]    [8/5]     [5/3]      [9/5]      [15/8]   2

f 99 0 2048 10 1 0.5 0.2 .1 .05 .025 .0125 .00625

f 0 3600	;DUMMY SCORE EVENT - PERMITS REALTIME PERFORMANCE FOR 1 HOUR 

</CsScore>

</CsoundSynthesizer>