<CsoundSynthesizer>
<CsOptions>
</CsOptions>

<CsInstruments>
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;				  The Monolyth
;				       by
;				Jean-Luc Cohen
;			     Berklee College of Music
;							   braces@xensei.com
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

sr=44100
kr=4410
ksmps=10
nchnls=2



instr 1

;p3 = duration of note
;p4 = amplitude of carrier
;p5 = freq of carrier
;p6 = start freq of modulator
;p7 = endin freq of modulator
;p8 = start amp of carrier
;p9 = endin amp of modulator
;p10 = time 2 for carrier env



k1 expseg p6, p3, p7				;envellope for modulator freq
k2 linseg p8, p3, p9				;envellope for modulator amp
k3 linseg 0, p10, p4, p11, 0		;envellope for carrier amp

alfo oscil 1000, 5, 3					;lfo
a2   oscil k1, k2, 2					;modulating oscilator
a1   oscil (k3+alfo), p5+a2, 1			;carrier oscilator

adel delay a1, .5

outs a1*.5,adel*.5


endin


	instr 2		; bell like sound




a8 oscil 80, (p5*.52), 3
k2 expon p4, p3,  .001 		  	; carrier env
a1 oscil k2, p5*a8/8 , 3   		;carrier oscil


k3 expon 6000, p3, .01    		;mod env
a2 oscil k3, p5+1.17, 3			; mod oscil

k9 expon 6000, p3, .001
a3 oscil k9, p5+2.75, 3

k9 expon 3000, p3, .001
a4 oscil k9, p5+111, 3

k9 expon 5000, p3, .001
a5 oscil k9, p5+.56, 3

k9 expon p4, p3, .1
a6 oscil k9, (p5/2)  ,3        	; sine wave


a5=a1+a2+a3+a4+a5+a6            ;defining output
ga5=a5

outs a5*.25,a5*.25             			;mix out dry+verb
endin


		instr 3  ; plucked instrument



k1 expon 15000, p3/2, 10         ; envellope 4 lp filter left
k2 expon 1000, p3, 2775          ; envellope 4 lfo amp
k3 expon 1, p3, 8                      ; envellope 4 lfo freq
k4 expon 20000, p3, 3    					; envellope 4 lp filter right

a4 oscil 300, 15000, 4             ;oscil 4 ringmod

alfo oscil k2, k3, 3                   ;  lfo

a1 pluck 10000, 32, 128, 0, 3, 1

a3 = (a1*a4) + alfo                   ; ringmod+lfo

al butterlp  a3, k1                    ; lp filter left

a5 vdelay a3, 200, 10000         ; delay right

ar butterlp a5, k4                     ; lp filter right

outs al / 60,  ar / 60

endin


				

		instr 14       ; Random midrotonal instrument


iseed = p6
idur=p3
 klforate linseg 5, p3, 25
kindex randh int(15), klforate, iseed
	k1 oscil 2,4,1														;vib
	kpitch table abs(kindex), 25
	

k1 oscil 2,4,1														;vib
	
a1 fof  p4,cpspch(kpitch)+k1,150,1, 60, .01, .1, .05, 20000, 1, 19, 100
a2 fof  p4,cpspch(kpitch)+k1, 50,1, 60, .001, .1,.05, 20000, 1, 19, 100

a5=(a1/2)+(a2/2)
	
	;display a5, .1

kpan linseg 1, p3, 0
kmp linseg 0.5,5*(p3/6), 1, p3/6, 0
outs (a5*kmp)/10, a5	* kmp


endin

		instr 15 ; yet another random microtonal instrument


iseed = p5
idur=p3
 klforate linseg 5, p3, 15
kindex randh int(15), klforate, iseed
	k1 oscil 2,4,1														;vib
	kpitch table abs(kindex), 26
	


k1 oscil 2,4,1														;vib
	
a1 fof  5000,cpspch(kpitch)+k1,500,2, 120, .01, .05 , .5, 20000, 3,19, 100
a2 fof  5000,cpspch(kpitch)+k1,1500  ,2, 120, .001, .05 , .5, 20000, 3,19, 100

a5=(a1+a2)
	
kmp linseg 0.2,5*(p3/6), 1, p3/6, 0
	

kpan linseg 1, p3, 0

outs (a5/2)*kmp,(a5*kmp)/10


endin


instr 10 ;   Granular synthesis
	
	
	kamp	linseg   1500, p3, 3000
	kpcs	linseg	  660, p3, 520
	kdens   linseg    1,  p3, 400
	kenv    linseg    .001, p3*.5, .9
	kvar1   linseg    50, p3/2, 10
	kvar2   linseg    60, p3/2, 10
	
	a1		grain	kamp, kpcs    , kdens, 50, kvar1,kenv, 1, 2, .9
	a2		grain	kamp, kpcs*.87, kdens, 60, kvar2,kenv, 1, 2, .9
	
	
	
	
			outs a1/2, a2/2

endin

instr 20
	
	
	kamp	linseg   1000, p3, 2000
	kpcs	linseg	  1220, p3, 745
	kdens   linseg    5,  p3, 250
	kenv    linseg    .001, p3*.5, .9
	
	a1		grain	kamp, kpcs    , kdens, 50, 20,kenv, 3, 2, .9
	a2		grain	kamp, kpcs*.87, kdens, 60, 20,kenv, 1, 2, .9
	
	
	
	
			outs a1/2, a2/2
				
endin


instr 30
	
	
	kamp	linseg   1000, p3, 1500
	kpcs	linseg	  2390, p3, 2390
	kdens   linseg    10,  p3, 10
	kenv    linseg    .001, p3*.5, .9
	
	a1		grain	kamp, kpcs    , kdens, 50, 20,kenv, 1, 2, .9
	a2		grain	kamp, kpcs*.87, kdens, 60, 20,kenv, 2, 2, .9
	
	
	;a3		grain	kamp, 1600*kp, 500, 0, 10,.05, 1, 2, .1
	
			outs a1/2, a2/2
				
endin
</CsInstruments>

<CsScore>
f1 0 4096 10 1 .221 0.440000 .3 .4
f2 0 2048 10 1 .9 .8 .7 .6 .5
f3 0 4096 10 1
f4 0 1024 10 1 .2 .6 .8 .4 .7
f5 0 1024 10 1 .5 .5 .6  .3  .7  .5
f6 0 1024 20 6
f7 0 1024 10 1 .5
f19 0 1024 19 .5 .5 270 .5
f25 0 16 -2  7.01  7.06  7.02   7.10  7.11  7.07  7  7.03  7.04  7.09
7.05  7.023 7.054 7.13 7.091
f26 0 16 -2  8.01  8.06  8.02   8.10  8.11  8.07  8  8.03  8.04  8.09
8.05  8.023 8.054 8.13 8.091



;p1 	p2 	p3	p4		p5		p6		p7		p8		p9		p10		p11

 i1 	0 	60 	9000 	80		110		5200	1000	9000	15		15
 i1 	0.1 60 	9000 	40		110		5200	1000	9000	15		15
 i1 	0 	60 	5000 	8000	107		5200	1000	9000	15		15
 i1 	0 	60 	7000 	2000	109		5200	1000	9000	15		15


 i3 0 10

 i2 15 45 7000 98
 i2 15 45 7000 40
 i2 15 45 7000 200

 i2 18 45 7000 120
 i2 18 45 7000 60
 i2 18 45 7000 200

 i2 20 40 7000 50
 i2 20 40 7000 20
 i2 20 40 7000 100

 i3 31 10
 i3 33 10

 i2 35 45 7000 50

 i2 23 65 7000 500

 i2 27 45 7000 1000





i2    61      64    700       1000
i2    67      65    300       2000
i2    67	  74    300       4000
i2    69      70    500       3700
i2    71      73    600       3600
i2    74      77    600       3500
i2    77      80    400       3450
i2    82      90    1000      40
i2    87      94    250       2000
i2    87      94    250       2100
i2    87      94    250       2150
i2    87      94    250       2200

i1 	  60 	  40 	9000 	80		1100	80000	1000	12000	30		10

i14   60      40   23000      .9
i15   76      26   23000      .1





i10 104  50

i20 110 44





 e




</CsScore>
</CsoundSynthesizer>